"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.normalize_options = exports.default = void 0;
var reselect_1 = require("reselect");
var default_extensions = ['js', 'jsx', 'ts', 'tsx'];
var default_platforms = {
    windows: ['windows', 'desktop', 'web'],
    macos: ['macos', 'osx', 'desktop', 'web'],
    desktop: ['desktop', 'web'],
    ios: ['ios', 'native'],
    android: ['android', 'native'],
};
var default_transform_functions = [
    'require',
    'require.resolve',
    'System.import',
    // Jest methods
    'jest.genMockFromModule',
    'jest.mock',
    'jest.unmock',
    'jest.doMock',
    'jest.dontMock',
    'jest.setMock',
    'jest.requireActual',
    'jest.requireMock',
    // Older Jest methods
    'require.requireActual',
    'require.requireMock',
];
var normalize_options = (0, reselect_1.createSelector)(function (opts) { return opts; }, function (opts) {
    var transform_functions = __spreadArray(__spreadArray([], default_transform_functions, true), (opts.transform_functions || []), true);
    var extensions = opts.extensions || default_extensions;
    var platforms = __assign(__assign({}, default_platforms), (opts.platforms || {}));
    var platform = opts.platform || 'desktop';
    var platform_extensions = platforms[platform];
    return {
        transform_functions: transform_functions,
        extensions: extensions,
        platforms: platforms,
        platform: platform,
        platform_extensions: platform_extensions,
    };
});
exports.default = normalize_options;
exports.normalize_options = normalize_options;
//# sourceMappingURL=options.js.map