"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.find_platform_import_path = exports.is_import_call = exports.is_normal_call = void 0;
var path = __importStar(require("path"));
var fs = __importStar(require("fs"));
var is_normal_call = function (node_path, types, functions) {
    var node = node_path.node;
    return functions.some(function (pattern) {
        if (types.isMemberExpression(node)) {
            return node_path.matchesPattern(pattern);
        }
        if (!types.isIdentifier(node) || pattern.includes('.')) {
            return false;
        }
        var name = pattern.split('.')[0];
        return node.name === name;
    });
};
exports.is_normal_call = is_normal_call;
var is_import_call = function (node_path, types) {
    if (!types.isCallExpression(node_path.node))
        return false;
    return types.isImport(node_path.node.callee);
};
exports.is_import_call = is_import_call;
var strip_extension = function (filepath, extensions) {
    var ext = path.extname(filepath);
    if (extensions.includes(ext)) {
        return filepath.substring(0, filepath.length - (ext.length + 1));
    }
    return filepath;
};
var find_platform_import_path = function (filepath, basedir, platform_extensions, extensions) {
    var filepath_stripped = strip_extension(filepath, extensions);
    for (var _i = 0, platform_extensions_1 = platform_extensions; _i < platform_extensions_1.length; _i++) {
        var platform_extension = platform_extensions_1[_i];
        for (var _a = 0, extensions_1 = extensions; _a < extensions_1.length; _a++) {
            var extension = extensions_1[_a];
            var alternative_filepath = "".concat(filepath_stripped, ".").concat(platform_extension, ".").concat(extension);
            var absolute_filepath = path.isAbsolute(alternative_filepath)
                ? alternative_filepath
                : path.resolve(basedir, alternative_filepath);
            if (fs.existsSync(absolute_filepath)) {
                return alternative_filepath;
            }
        }
    }
    // handle /module/index.<platform>.js case
    for (var _b = 0, platform_extensions_2 = platform_extensions; _b < platform_extensions_2.length; _b++) {
        var platform_extension = platform_extensions_2[_b];
        for (var _c = 0, extensions_2 = extensions; _c < extensions_2.length; _c++) {
            var extension = extensions_2[_c];
            var alternative_filepath = "".concat(filepath_stripped, "/index.").concat(platform_extension, ".").concat(extension);
            var absolute_filepath = path.isAbsolute(alternative_filepath)
                ? alternative_filepath
                : path.resolve(basedir, alternative_filepath);
            if (fs.existsSync(absolute_filepath)) {
                return alternative_filepath;
            }
        }
    }
    return null;
};
exports.find_platform_import_path = find_platform_import_path;
//# sourceMappingURL=utils.js.map